<?php
interface ISaver
{
    public function read();
    public function write($data);
}

class SaverFile implements ISaver
{
    private $filePath;

    function __construct($file_path)
    {
        $this->filePath = $file_path;
        
        if (!file_exists($this->filePath) ) {
            $fp = fopen($this->filePath, 'w');
            if (! $fp) {
                throw new Exception(__CLASS__.'. Can\'n create file - '.$this->filePath);
            }
            fclose($fp);
        }
        
        if (!is_writable($this->filePath)) {
            throw new Exception(__CLASS__.'. The file - '.$this->filePath.' is not writable');
        }
    }

    function read()
    {
        $t = file_get_contents($this->filePath);
        return $t ? unserialize($t) : null;
    }

    function write($date)
    {
        $fp = fopen($this->filePath, "w");
        if (! $fp) {
            throw new Exception(__CLASS__.". Can't open file - ".$this->filePath);
        }
        fwrite($fp, serialize($date));
        fclose($fp);
    }
}

class Storage
{

    private $storage = array();

    private $saver;

    function __construct(ISaver $saver)
    {
        $this->saver = $saver;
        $this->storage = $saver->read();
    }

    function __destruct()
    {
        //$this->save();
    }

    function __get($name)
    {
        return isset($this->storage[$name]) ? $this->storage[$name] : null;
    }

    function __set($name, $val)
    {
        $this->storage[$name] = $val;
    }

    function getAll()
    {
        return $this->storage;
    }

    function save()
    {
        $this->saver->write($this->storage);
    }
}
?>