<?php
/**
 * Tree
 */
class AboTree
{
    protected $childs = array();
    
    /**
     * Constructor
     */
    function __construct($root_key, $data = array())
    { 
        $this->items[$root_key] = new AboTreeNode(null, $root_key, $data);
    }

    /**
     * Destructor
     */
    function __destruct() {}
    
    public function addNode($parent_key, $node_key, $data = array())
    {
        if (isset($this->items[$node_key])) {
            throw new Exeption('Class '.__CLASS__.', '.__METHOD__.'. Node with key '.$node_key.' already exists');
        }
        if (! isset($this->items[$parent_key])) {
            throw new Exeption('Class '.__CLASS__.', '.__METHOD__.'. Parent node with key '.$parent_key.' does not exists');
        }
    	$this->items[$node_key] = new AboTreeNode($this->items[$parent_key], $node_key, $data);
    }
    
    public function getNode($key)
    {
    	return $this->items[$key];
    }
    
    public function getRoot()
    {
    	return reset($this->items);
    }
    
    public function getNodeChilds($key = 0)
    {
        $node = $key ? $this->getNode($key) : $this->getRoot();
    	return $node ? $node->getChilds() : false;
    }
    
    public function toHtml($node_tpl_str = '', $root_key = 0)
    {   static $iter = 0,
        $main_tpl = "<dl class=\"{css_class_leaf} {css_class_open} {css_class_close} {css_last_class}\"><dt></dt><dd>{node-item}</dd>
{blck_content}
</dl>",
        $node_tpl = "<a href=\"{link}\">{title}</a>",
        $content_tpl = "<dd class=\"content\">
{content}
</dd>";
        if (0 == $iter) {
            $node = $this->getRoot();
            if ($node_tpl_str) {
                $node_tpl = $node_tpl_str;
            }
            if (0 == $root_key) {
                $node = $this->getRoot();
            } else {
                $node = $this->getNode($root_key);
            }
        } else {
            $node = $node = $this->getNode($root_key);
        }
        $leaf = $open = $close = $last = '';
        $chs = $node->getChilds();
        if (empty($chs)) {
            $leaf = 'leaf';
        } else {
            $open = 'open';
        }
        if ($node->isLastChild()) {
            $last = 'last';
        }
        $content = $content_blck = '';
    	if ($node->hasChilds()) {
    	    $chs = $node->getChilds();
    	    foreach ($chs as $ch) {
    	        $iter++;
    	    	$content .= $this->toHtml('', $ch->getKey());
    	    	$iter--;
    	    }
    	    $content_blck = str_replace('{content}', $content, $content_tpl);
    	}
    	$node_data = $node->getData();
    	$patt = array();
    	$repl = array();
    	foreach ($node_data as $key => $val) {
    		$patt[] = "{".$key."}";
    		$repl[] = $val;
    	}
    	$node_item = str_replace($patt, $repl, $node_tpl);
    	return str_replace(
    	    array('{css_class_leaf}', '{css_class_open}', '{css_class_close}',
    	        '{css_last_class}', '{node-item}', '{blck_content}'),
    	    array($leaf, $open, $close, $last, $node_item, $content_blck),
    	    $main_tpl
    	);
    }
    
    public function toList($root_key = 0)
    {   static $iter = 0, $level = 0, $ret = array();
        if (0 == $iter && 0 == $root_key) {
            $node = $this->getRoot();
        } else {
            $node = $this->getNode($root_key);
        }
        $node_data = $node->getData();
        $node_data['level'] = $level;
        $node_data['has_child'] = false;
        $node_data['is_last_child'] = $node->isLastChild();
        $ret[$node->getKey()] = &$node_data;
    	if ($node->hasChilds()) {
    	    $node_data['has_child'] = true;
    	    $level++;
    	    $chs = $node->getChilds();
    	    foreach ($chs as $ch) {
    	        $iter++;
    	    	$this->toList($ch->getKey());
    	    	$iter--;
    	    }
    	    $level--;
    	}
    	if (0 == $iter) {
    	    $_ret = $ret;
    	    $ret = array();
    	    return $_ret;
    	}
    }
    
    function __toString() {
        return '';
    }
}

class AboTreeNode implements arrayAccess {
    protected $key;
    protected $data;
    protected $parent;
    protected $childs = array();
    
    public function __construct($parent, $key, $data = array())
    {         
        $this->key = $key;
        $this->data = $data;
        if ($parent instanceof self) {
            $this->parent = $parent;
            $this->parent->childs[] = $this;
        }        
    }
    
    public function getKey() { return $this->key; }
    
    public function getData() { return $this->data; }
    
    public function getParent() { return $this->parent; }
    
    public function getChilds() { return $this->childs; }
    
    public function hasChilds() { return empty($this->childs) ? false : true; }
    
    public function fstChild() { return empty($this->childs) ? false : $this->childs[0]; }
    
    public function isLastChild() {
        $ret = true;
        if ( $parent = $this->getParent() ) {
            $childs = $parent->getChilds();
            $ret = $this == $childs[count($childs)-1];
        }
        return $ret;
    }
    
    public function offsetSet($offset, $value) {
        if ($offset) {
            $this->data[$offset] = $value;
        }
    }
    
    public function offsetExists($offset) {
        return isset($this->data[$offset]);
    }
    
    public function offsetUnset($offset) {
        unset($this->data[$offset]);
    }
    
    public function offsetGet($offset) {
        return isset($this->data[$offset]) ? $this->data[$offset] : null;
    }
    
    public function __get($name)
    {
    	return isset($this->data[$name]) ? $this->data[$name] : null;
    }
    
    public function __set($name, $val)
    {
        $this->data[$name] = $val;
    	return true;
    }
}
?>