<?php
function repl_entities($text)
{
	return str_replace(
	   array(
	       "€", "¢", "£", "¤", "¥", "¦",
	       "§", "©", "«", "»", "¬", "®",
	       "°", "±", "²", "³", "µ", "¶",
	       "·", "¹", "¼", "½", "×", "÷"
	   ),
	   array(
	       "&euro;", "&cent;", "&pound;", "&curren;", "&yen;", "&brvbar;",
	       "&sect;", "&copy;", "&laquo;", "&raquo;", "&not;", "&reg;",
	       "&deg;", "&plusm;", "&sup2;", "&sup3;", "&micro;", "&para;",
	       "&middot;", "&sup1;", "&frac14;", "&frac12;", "&times;", "&divide;"
	   ),
	   $text
	);
}

function arr_to_csv_line($arr, $delimiter = ';', $enclosure = '"')
{
    $line = array();
    foreach ($arr as $v) {
        if (false !== strpos($v, $delimiter) || false !== strpos($v, $enclosure) || false !== strpos($v, "\n")) {
            $v = $enclosure.str_replace($enclosure, $enclosure.$enclosure, $v).$enclosure;
        }
        $line[] = $v;
    }
    return implode($delimiter, $line);
}

function abo_strlen($str)
{
	return function_exists('mb_strlen') ? mb_strlen($str) : strlen($str);
}

function abo_strtolower($str)
{
	return function_exists('mb_strtolower') ? mb_strtolower($str) : strtolower($str);
}

function abo_strtoupper($str)
{
	return function_exists('mb_strtoupper') ? mb_strtoupper($str) : strtoupper($str);
}

function abo_substr($str, $start)
{
    $param = func_get_args();
	return call_user_func_array(function_exists('mb_substr') ? 'mb_substr' :  'substr', $param);
}

function abo_chunk_split ($str, $chunklen = 76, $end = "\r\n")
{
    $ret = "";
	for ($i = 0, $l = abo_strlen($str); $i < $l; $i++) {
	    if ($i > 0 && 0 == $i % $chunklen && $i != $l-1) {
	        $ret .= $end;
	    }
	    $ret .= abo_substr($str, $i, 1);
	}
	return $ret;
}

function abo_str_crop($str, $len = 0, $suff = null)
{   global $CONFIG;

    $len = $len > 0 ? $len : $CONFIG['str_default_crop_len'];
    $suff = is_null($suff) ? $CONFIG['str_default_crop_suff'] : $suff;
	return abo_strlen($str) > $len ? abo_substr($str, 0, $len).$suff : $str;
}

function abo_str_array_crop(&$array, $len = 0, $suff = null)
{
    if (is_array($array)) {
        foreach ($array as $key => $val) {        
        	if (is_array($val)) {
        	    abo_str_array_crop($array[$key], $len, $suff);
        	} else {
        	    $array[$key] = abo_str_crop($val, $len, $suff);
        	}
        }
    }
}

function abo_float($val)
{
	return str_replace(',', '.', floatval($val));
}

function abo_quote_encode($str)
{
	return str_replace(array('"', "'"), array('&quot;', '&#039;'), $str);
}

function abo_is_ajax()
{
    return $_REQUEST['type'] == "JsHttpRequest" || isset($_SERVER['HTTP_X_REQUESTED_WITH']);
}

function abo_geo_by_ip($ip)
{
    $ret = false;
    $xml = '';
    // http://ipgeobase.ru:7020/geo?ip='.$ip
    $fp = fsockopen("ipgeobase.ru:7020", 80);
    if ($fp) {
        fwrite($fp, "GET /geo?ip={$ip} HTTP/1.0\r\n\r\n");
        stream_set_timeout($fp, 5);
        $read_body = false;
        while ($line = @fgets ($fp, 1024)){
            if (!$read_body && preg_match ("~^[\r]?\n$~i", $line)) {
                $read_body = true;
            } else if ($read_body) {
                $xml .= $line;
            }
        }
        $info = stream_get_meta_data($fp);
        fclose($fp);

        if ($res && ! $info['timed_out']) {
            $xml = $res;
        }
    }
    $dom = new DomDocument('1.0', 'windows-1251');
    if ($xml && $dom->loadXML($xml)) {
        if ($node = $dom->getElementsByTagName("city")) {
            $ret['city'] = $node->item(0)->textContent;
        }
        if ($node = $dom->getElementsByTagName("region")) {
            $ret['region'] = $node->item(0)->textContent;
        }
    }
    return $ret;
}

function detect_mobile_device()
{
    // check if the user agent value claims to be windows but not windows mobile
    if(stristr($_SERVER['HTTP_USER_AGENT'],'windows')&&!stristr($_SERVER['HTTP_USER_AGENT'],'windows ce')){
        return false;
    }
    // check if the user agent gives away any tell tale signs it's a mobile browser
    if(preg_match('/up\.browser|up\.link|windows ce|iemobile|mini|mmp|symbian|midp|wap|phone|pocket|mobile|pda|psp|iphone|ipod/i',$_SERVER['HTTP_USER_AGENT'])){
        return true;
    }
    // check the http accept header to see if wap.wml or wap.xhtml support is claimed
    if(stristr($_SERVER['HTTP_ACCEPT'],'text/vnd.wap.wml')||stristr($_SERVER['HTTP_ACCEPT'],'application/vnd.wap.xhtml+xml')){
        return true;
    }
    // check if there are any tell tales signs it's a mobile device from the _server headers
    if(isset($_SERVER['HTTP_X_WAP_PROFILE'])||isset($_SERVER['HTTP_PROFILE'])||isset($_SERVER['X-OperaMini-Features'])||isset($_SERVER['UA-pixels'])){
        return true;
    }
    // build an array with the first four characters from the most common mobile user agents
    $a = array('acs-', 'alav', 'alca', 'amoi', 'audi', 'aste', 'avan', 'benq', 'bird', 'blac',
            'blaz', 'brew', 'cell', 'cldc', 'cmd-', 'dang', 'doco', 'eric', 'hipt','inno', 'ipaq',
            'java','jigs','kddi','keji','leno','lg-c','lg-d','lg-g','lge-','maui','maxo','midp','mits',
            'mmef','mobi','mot-','moto','mwbp','nec-','newt','noki','opwv','palm','pana','pant','pdxg',
            'phil','play','pluc','port','prox','qtek','qwap','sage','sams','sany','sch-','sec-','send',
            'seri','sgh-','shar','sie-','siem','smal','smar','sony','sph-','symb','t-mo','teli','tim-',
            'tosh','treo','tsm-','upg1','upsi','vk-v','voda','wap-','wapa','wapi','wapp','wapr','webc',
            'winw','winw','xda-');
    // check if the first four characters of the current user agent are set as a key in the array
    $s = strtolower(substr($_SERVER['HTTP_USER_AGENT'],0,4));
    if(in_array($s, $a)){
        return true;
    }
}

function abo_get_ip()
{
    $ret = false;
    if ($_SERVER['HTTP_X_FORWARDED_FOR']){
        $ret = $_SERVER['HTTP_X_FORWARDED_FOR'];
    } elseif ($_SERVER['HTTP_FORWARDED_FOR']) {
        $ret = $_SERVER['HTTP_FORWARDED_FOR'];
    } else {
        $ret = $_SERVER['REMOTE_ADDR'];
    }
    if ($ret) {
        $ret = preg_split('/[^\d.]/', $ret);
        $ret = $ret[0];
    }

    return $ret;
}

if (function_exists('mb_internal_encoding')) {
    mb_internal_encoding("UTF-8");
}
?>